evtSettingsBank_Save equ %10010000+15
evtSettingsBank_Load equ %10010000+0
evtMultipleCommands equ %01110000


evtSetMoveLife     equ 128
evtSetProg	   equ 129
evtSetLife	   equ 130
evtSetMove	   equ 131
evtSetProgMoveLife equ 132
evtSetSprite	   equ 133
evtAddToForeground equ 135
evtAddToBackground equ 134
evtJumpToNewTime   equ 136
evtCallAddress	   equ 137
evtSaveLstObjToAdd equ 138
evtResetPowerup    equ 139
evtSetLevelSpeed   equ 140

evtReprogramPalette 	equ %11110000
evtReprogramBackground 	equ %11110001	
evtReprogramHitHandler 	equ %11110010		
evtReprogramParalax	equ %11110011		

evtReprogramCustomMove1 equ %11110100
evtReprogramCustomMove2 equ %11110101
evtReprogramCustomMove3 equ %11110111
evtReprogramCustomMove4 equ %11111000

evtReprogramCustomProg1 equ %11111001
evtReprogramCustomProg2 equ %11111010
evtReprogramCustomProg3 equ %11111011
evtReprogramCustomProg4 equ %11111100


evtReprogram_PowerupSprites equ %11110110
evtReprogramScrollDirection equ %11111101	; 0-Left (Default) 1-Right 2-Up 3-Down
evtReprogramObjectFullCustomMoves equ	%11111110

evtReprogramSmartBombSpecial equ	%11111111

evtSingleSprite equ 0

;Time,type,Sprite,XY (16 px precision)

; Types:
;type XXXX----
;     00000000 A X Y = (0)  add one object A=sprnum, X , Y
;     00000001 Y    	Add one sprite to pos Y Far right (Same sprite as last time
;     0000yyyy A	2-13 add one 24 pixel object far right X=160+24 Y*16 -8 (Same sprite as last time
;     0001xxxx A B = (16) add  xxxx objects
;     0010xxxx X B = (32) add  xxxx objects all on column X
;     0011xxxx X Y S = (48) add  xxxx objects all on column X, Ypos Spaced S apart vertically
;     0100xxxx X Y   = (64) add stars to X,Y (pattern xxxx)
;     0101       Unused
;     0110       Unused
;     0111xxxx  = (112) Read Multiple events at the same time point

;     10000000 M L = (128) Change object movement to M, Life to L
;     10000001 P = (129) Change object Program
;     10000010 L = (130) Change object Life
;     10000011 M = (131) Change object Move
;     10000100 P M L = (132) Change object Program Move and Life
;     10000101 S = (133) Change object Sprite (only works with 0000XXXX )
;     10000110 (134) Add Objects to Front of list first (Background)
;     10000111 (135) Add Objects to Back of list first (Foreground)
;     10001000 L H T (136) = Load HL as next event pointer, change time to T
;     10001001 L H   (137) = Call HL - (untested)
;     10001010 L H   (138) = Load last added object address to address HL
;     10011111 B = Save to bank B
;     1001XXXX 	Load object settings (Prog, Move,Life) from XXXX bank (0-14 - see above 15 is save command)
;		Use this function to create template enemy moves and background object types
;     1010       Unused
;     1011       Unused	
;     1100XXXX   Unused
;     1101XXXX   Unused
;     1110XXXX   Unused
;     1111XXXX   Reprogram memory chunk

;     1111XXXX   Reprogram memory chunk
;     11110000 O B	X X X  = (240) Reprogram palette (B no of Bytes, O = offset; X X X byte data)
;     11110001 O B	X X X  = (240) Reprogram Background (B no of Bytes (up to 41), O = offset; X X X byte data)
;     11110010 LH 	= when an object is shot jump to HL (Akuyou_Object_DecreaseLifeShot is true hitcounter)
;     11110011 1P2	= Scroll rate 1 before P then 2 (1 must be faster than 2)
;     11110100 LH	= Reprogram Custom Move1
;     11110101 LH	= Reprogram Custom Move2

; Life BPxxxxx 		B=hurt by bullets , P hurts player, xxxxxx = Life ... Life decreases either over time or due to hits %00000000 means an immortal object which will only dissapear if it goes ofscreen

;Domoves
;0MYYYXXX	; Linear move
;11ddXXXX	; Background (Slow) move
;100001XX	; Seek player 1 speed -----XX1
;1010DSPP	D = Depth bit, S= Speed, PP Position


evtTileSprite equ 48 ;     0011xxxx X Y S = (48) add  xxxx objects all on column X, Ypos Spaced S apart vertically

prgNothing	equ 0
PrgSpare	equ 1 ;Does not get killed by smartbomb
prgSpecial	equ 2
prgBonus 	equ 3
prgMovePlayer	equ 4
prtSpriteAlt	equ 5

prgCustom1Protected 	equ 8				;Custom 1 - protected from smart bomb

;Not programmed in yet
;prgCustom2Protected 	equ 9				;Custom 2 - protected from smart bomb
;prgCustom3Protected 	equ 10				;Custom 3 - protected from smart bomb
;prgCustom4Protected 	equ 11				;Custom 4 - protected from smart bomb


;All under 31 Do not get killed by smartbomb except 0
prgFireSnail	equ %10000000
prgFireSlow	equ %01100000
prgFireMid	equ %01000000
prgFireMid2	equ %11000000
prgFireFast	equ %00100000
prgFireHyper	equ %10100000

; Fire Patterns

;defw	Stars_AddObject			;0 = just one - Special use only
;defw	Stars_AddBurst_TopLeft		;1
;defw	Stars_AddBurst_BottomLeft	;2
;defw	Stars_AddBurst_TopRight		;3
;defw	Stars_AddBurst_BottomRight	;4
;defw	Stars_AddBurst_Top		;5
;defw	Stars_AddBurst_Bottom		;6
;defw	Stars_AddBurst_Left		;7
;defw	Stars_AddBurst_Right		;8
;defw	Stars_AddBurst_TopWide		;9
;defw	Stars_AddBurst_BottomWide	;10
;defw	Stars_AddBurst_LeftWide		;11
;defw	Stars_AddBurst_RightWide	;12
;defw	Stars_AddBurst	All Dirs	;13
;defw	Stars_AddBurst	All Dirs Small	;14
;defw					;15
;	Fire W				 16 
;	Fire NW				 17
;	Fire N				 18

prgCustom1 	equ %11111100			;Custom 1
prgCustom2 	equ %11111101			;Custom 2
prgCustom3 	equ %11111110			;Custom 3
prgCustom4 	equ %11111111			;Custom 4


mveStatic 	equ &24
mveBackground   equ %11000000
mveSeaker	equ %10000100
mveWave		equ %10100000
;mveWaveSmall	equ %10010000 depricated
mveCustom1	equ %11110000
mveCustom2	equ %11100000
mveCustom3	equ %11010000
mveCustom4	equ %10110000

;	Moves - Regular
;		0	1	2	3	4	5	6	7
;		-4	-3	-2	-1	0	1	2	3
;-4	0	00	01	02	03	 04	05	06	07
;-3	1	08	09	0A	0B	 0C	0D	0E	0F
;-2	2	10	11	12	13	 14	15	16	17
;-1	3	18	19	1A	1B	 1C	1D	1E	1F

;0	4	20	21	22	23	[24]	25	26	27

;1	5	28	29	2A	2B	 2C	2D	2E	2F
;2	6	30	31	32	33	 34	35	36	37
;3	7	38	39	3A	3B	 3C	3D	3E	3F



;	Moves - Fast
;		0	1	2	3	4	5	6	7
;		-4	-3	-2	-1	0	1	2	3
;-4	0	40	41	42	43	 44	45	46	47
;-3	1	48	49	4A	4B	 4C	4D	4E	4F
;-2	2	50	51	52	53	 54	55	56	57
;-1	3	58	59	5A	5B	 5C	5D	5E	5F

;0	4	60	61	62	63	[64]	65	66	67

;1	5	68	69	6A	6B	 6C	6D	6E	6F
;2	6	70	71	72	73	 74	75	76	77
;3	7	78	79	7A	7B	 7C	7D	7E	7F


lifCustom       equ 255		; We use 63 as a marker for custom code's INIT - a real life will be set by the custom code
lifEnemy	equ %11000000	;HurtByBullets,Hurts Player
lifTimed	equ %00000000	;Doesnt hurt, dies automatically
lifDeadly	equ %01000000	;Deadly and cant be shot
TwoFrameSprite  equ 128


