read "CoreDefs.asm"




limit &E00	
org &50


;
;Rastercolor buffer - 80 bytes (&50
RasterColors_ColorArray1:
	defb 1
	defb 1
	defb 64+20,64+24,64+29,64+11	 :IlluminatedPaletteA_Plus2
RasterColors_ColorArray2:
	defb 1
	defb 1

	defb 64+20,64+12,64+13,64+11	:IlluminatedPaletteB_Plus2
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 12
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+24,64+29,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray3:
	defb 1
	defb 1
	defb 64+20,64+12,64+13,64+11 :IlluminatedPaletteC_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
RasterColors_ColorArray4:
	defb 1
	defb 1 
	defb 64+20,64+31,64+14,64+11 :IlluminatedPaletteD_Plus2
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11
	defb 0
	defb 64+20,64+12,64+13,64+11
	defb 0
	defb 64+20,64+31,64+14,64+11



align 256,&00
StarArraySize equ 255
StarArrayPointer: 	
defs StarArraySize*3,&00


ObjectArraySize equ 60
PlayerStarArraySize equ 36

align 256,&00
PlayerStarArrayPointer: 
defs 64,&00
ObjectArrayPointer:
defs 64,&00
align 256,&00
defs 255*5,&00

;defs ObjectArraySize*6,&00
;defs PlayerStarArraySize*3,&00

;align 256,&00

	

Event_SavedSettings:
defs 4*16,&00

CustomRam:
defs 32 ;  Pos-Tick-Pos-Tick ; enough memory for 16 enemies!



;E00 - Memory Location of SFX


limit &2000
org &1000
;incbin "Sprites\PLAYER.SPR"

limit &FFFF

org &2A00
LevelSprites:
;incbin "Sprites\LEVEL1A2.SPR"
incbin "Sprites\LEVEL5.SPR"

limit &3ff0 
; This level has few sprites, but a smeg load of code!
org &3800


evtSettingsBank_Save equ %10010000+15
evtSettingsBank_Load equ %10010000+0
evtMultipleCommands equ %01110000


evtSetMoveLife     equ 128
evtSetProg	   equ 129
evtSetLife	   equ 130
evtSetMove	   equ 131
evtSetProgMoveLife equ 132
evtSetSprite	   equ 133
evtAddToForeground equ 135
evtAddToBackground equ 134
evtJumpToNewTime   equ 136
evtCallAddress	   equ 137
evtSaveLstObjToAdd equ 138
evtResetPowerup    equ 139
evtSetLevelSpeed   equ 140

evtReprogramPalette 	equ %11110000
evtReprogramBackground 	equ %11110001	
evtReprogramHitHandler 	equ %11110010		
evtReprogramParalax	equ %11110011		

evtReprogramCustomMove1 equ %11110100
evtReprogramCustomMove2 equ %11110101
evtReprogramCustomMove3 equ %11110111
evtReprogramCustomMove4 equ %11111000

evtReprogramCustomProg1 equ %11111001
evtReprogramCustomProg2 equ %11111010
evtReprogramCustomProg3 equ %11111011
evtReprogramCustomProg4 equ %11111100


evtReprogram_PowerupSprites equ %11110110
evtReprogramScrollDirection equ %11111101	; 0-Left (Default) 1-Right 2-Up 3-Down
evtReprogramObjectFullCustomMoves equ	%11111110

evtSingleSprite equ 0

;Time,type,Sprite,XY (16 px precision)

; Types:
;type XXXX----
;     00000000 A X Y = (0)  add one object A=sprnum, X , Y
;     00000001 Y    	Add one sprite to pos Y Far right (Same sprite as last time
;     0000yyyy A	2-13 add one 24 pixel object far right X=160+24 Y*16 -8 (Same sprite as last time
;     0001xxxx A B = (16) add  xxxx objects
;     0010xxxx X B = (32) add  xxxx objects all on column X
;     0011xxxx X Y S = (48) add  xxxx objects all on column X, Ypos Spaced S apart vertically
;     0100xxxx X Y   = (64) add stars to X,Y (pattern xxxx)
;     0101       Unused
;     0110       Unused
;     0111xxxx  = (112) Read Multiple events at the same time point

;     10000000 M L = (128) Change object movement to M, Life to L
;     10000001 P = (129) Change object Program
;     10000010 L = (130) Change object Life
;     10000011 M = (131) Change object Move
;     10000100 P M L = (132) Change object Program Move and Life
;     10000101 S = (133) Change object Sprite (only works with 0000XXXX )
;     10000110 (134) Add Objects to Front of list first (Background)
;     10000111 (135) Add Objects to Back of list first (Foreground)
;     10001000 L H T (136) = Load HL as next event pointer, change time to T
;     10001001 L H   (137) = Call HL - (untested)
;     10001010 L H   (138) = Load last added object address to address HL
;     10011111 B = Save to bank B
;     1001XXXX 	Load object settings (Prog, Move,Life) from XXXX bank (0-14 - see above 15 is save command)
;		Use this function to create template enemy moves and background object types
;     1010       Unused
;     1011       Unused	
;     1100XXXX   Unused
;     1101XXXX   Unused
;     1110XXXX   Unused
;     1111XXXX   Reprogram memory chunk

;     1111XXXX   Reprogram memory chunk
;     11110000 O B	X X X  = (240) Reprogram palette (B no of Bytes, O = offset; X X X byte data)
;     11110001 O B	X X X  = (240) Reprogram Background (B no of Bytes (up to 41), O = offset; X X X byte data)
;     11110010 LH 	= when an object is shot jump to HL (Akuyou_Object_DecreaseLifeShot is true hitcounter)
;     11110011 1P2	= Scroll rate 1 before P then 2 (1 must be faster than 2)
;     11110100 LH	= Reprogram Custom Move1
;     11110101 LH	= Reprogram Custom Move2

; Life BPxxxxx 		B=hurt by bullets , P hurts player, xxxxxx = Life ... Life decreases either over time or due to hits %00000000 means an immortal object which will only dissapear if it goes ofscreen

;Domoves
;0MYYYXXX	; Linear move
;11ddXXXX	; Background (Slow) move
;100001XX	; Seek player 1 speed -----XX1
;1010DSPP	D = Depth bit, S= Speed, PP Position


evtTileSprite equ 48 ;     0011xxxx X Y S = (48) add  xxxx objects all on column X, Ypos Spaced S apart vertically

prgNothing	equ 0
prgSpecial	equ 2
prgBonus 	equ 3
prgMovePlayer	equ 4
prtSpriteAlt	equ 5
prgFireSnail	equ %10000000
prgFireSlow	equ %01100000
prgFireMid	equ %01000000
prgFireMid2	equ %11000000
prgFireFast	equ %00100000
prgFireHyper	equ %10100000

; Fire Patterns

;defw	Stars_AddObject			;0 = just one - Special use only
;defw	Stars_AddBurst_TopLeft		;1
;defw	Stars_AddBurst_BottomLeft	;2
;defw	Stars_AddBurst_TopRight		;3
;defw	Stars_AddBurst_BottomRight	;4
;defw	Stars_AddBurst_Top		;5
;defw	Stars_AddBurst_Bottom		;6
;defw	Stars_AddBurst_Left		;7
;defw	Stars_AddBurst_Right		;8
;defw	Stars_AddBurst_TopWide		;9
;defw	Stars_AddBurst_BottomWide	;10
;defw	Stars_AddBurst_LeftWide		;11
;defw	Stars_AddBurst_RightWide	;12
;defw	Stars_AddBurst	All Dirs	;13
;defw	Stars_AddBurst	All Dirs Small	;14
;defw					;15
;	Fire W				 16 
;	Fire NW				 17
;	Fire N				 18

prgCustom1 	equ %11111100			;Custom 1
prgCustom2 	equ %11111101			;Custom 2
prgCustom3 	equ %11111110			;Custom 3
prgCustom4 	equ %11111111			;Custom 4


mveStatic 	equ &24
mveBackground   equ %11000000
mveSeaker	equ %10000100
mveWave		equ %10100000
;mveWaveSmall	equ %10010000 depricated
mveCustom1	equ %11110000
mveCustom2	equ %11100000
mveCustom3	equ %11010000
mveCustom4	equ %10110000

;	Moves - Regular
;		0	1	2	3	4	5	6	7
;		-4	-3	-2	-1	0	1	2	3
;-4	0	00	01	02	03	 04	05	06	07
;-3	1	08	09	0A	0B	 0C	0D	0E	0F
;-2	2	10	11	12	13	 14	15	16	17
;-1	3	18	19	1A	1B	 1C	1D	1E	1F

;0	4	20	21	22	23	[24]	25	26	27

;1	5	28	29	2A	2B	 2C	2D	2E	2F
;2	6	30	31	32	33	 34	35	36	37
;3	7	38	39	3A	3B	 3C	3D	3E	3F



;	Moves - Fast
;		0	1	2	3	4	5	6	7
;		-4	-3	-2	-1	0	1	2	3
;-4	0	40	41	42	43	 44	45	46	47
;-3	1	48	49	4A	4B	 4C	4D	4E	4F
;-2	2	50	51	52	53	 54	55	56	57
;-1	3	58	59	5A	5B	 5C	5D	5E	5F

;0	4	60	61	62	63	[64]	65	66	67

;1	5	68	69	6A	6B	 6C	6D	6E	6F
;2	6	70	71	72	73	 74	75	76	77
;3	7	78	79	7A	7B	 7C	7D	7E	7F


lifCustom       equ 255		; We use 63 as a marker for custom code's INIT - a real life will be set by the custom code
lifEnemy	equ %11000000	;HurtByBullets,Hurts Player
lifTimed	equ %00000000	;Doesnt hurt, dies automatically
lifDeadly	equ %01000000	;Deadly and cant be shot
TwoFrameSprite  equ 128




;org &2E00


EventStreamArray:

;defb 1,128,&24,128+64+60		; Move Static


defb 0,evtResetPowerup

defb 0,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	;
	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54		



; Define the background

defb 0,240+1,0,18*2+1				; (Time,Cmd,Off,Bytes) Load 41 bytes into the background - 41 bytes is the limit

defb &F0,&F0	;1; first line
defb 196,&D0	;2; line num, New byte
defb 190,&70	;3
defb 186,&A0	;4
defb 180,&50	;5
defb 176,&80	;6
defb 170,&20	;7
defb 166,&00	;8
defb 160,&00	;9
defb 80,&20	;10
defb 76,&80	;11
defb 70,&50	;12
defb 66,&A0	;13
defb 50,&80	;14
defb 40,&20	;15
defb 30,&00	;16
defb 28,&00	;17
defb 02,&00	;18
defb 255

;We will use 4 Paralax layers
; ---------()- (sky)		%11001000
; ------------ (Far)		%11000100
; -----X---X-- (mid)		%11000010	Bank 1
; []=====[]=== (foreground) 	%11000001	Bank 0


defb 0,evtReprogram_PowerupSprites,128+14,128+13,128+12,128+9	; sprites drone,speed,power,coin

; Background L
defb 0,128+4,1,%11000001,0			; Program - Bitshift Sprite... Move - dir Left Slow ... Life - immortal
defb 0,%10010000+15,0				; Save Object settings to Bank 0

defb 0,128+4,1,%11000010,0			; Program - Bitshift Sprite... Move - dir Left Slow ... Life - immortal
defb 0,evtSettingsBank_Save,1				; Save Object settings to Bank 1


; Tentitack
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,prgFireSlow+13,mveWave+%00000000,lifEnemy+6	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+0		
defb 	evtSettingsBank_Save,2


; Tentitack
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,prgFireSlow+13,mveWave+%00000001,lifEnemy+6	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+0		
defb 	evtSettingsBank_Save,3


; Starfish Bomber
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,prgFireMid+10,&23,lifEnemy+7	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+4		
defb 	evtSettingsBank_Save,4		


; LiliFrog
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,prgFireSlow+7,&23,lifEnemy+5	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+2		
defb 	evtSettingsBank_Save,5		

; SpitFish
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,prgFireFast+17,&23,lifEnemy+5	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+3		
defb 	evtSettingsBank_Save,6		


; Bubble
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,0,mveCustom2,lifCustom; Program - Fire Left... Move - wave... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+6			; Sprite 1 Frame animater
defb 	evtSettingsBank_Save,7

; Bubble Move
defb 0,evtReprogramCustomMove1
defw CustomMove1


; Bubble 2
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,0,mveCustom1+1,lifCustom; Program - Fire Left... Move - wave... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+7			; Sprite 1 Frame animater
defb 	evtSettingsBank_Save,8

; bubble Move 2
defb 0,evtReprogramCustomMove2
defw CustomMove2


; Super Fish
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,prgCustom1,mveCustom3+2,lifCustom; Program - Fire Left... Move - wave... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+1			; Sprite 1 Frame animater
defb 	evtSettingsBank_Save,9

; Super Fish Move
defb 0,evtReprogramCustomMove3
defw CustomMove3

defb 0,evtReprogramCustomProg1
defw CustomProgram1



; Pairanah
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,prgCustom2,&22,lifEnemy+20	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+5		
defb 	evtSettingsBank_Save,10		


defb 0,evtReprogramCustomProg2
defw CustomProgram2

; Miner Fish
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,prgFireHyper+16,mveWave+%00000000,lifEnemy+20	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+8
defb 	evtSettingsBank_Save,11


; Fish Face
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,prgFireSnail+13,&22,lifEnemy+30	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+10
defb 	evtSettingsBank_Save,12


;  Fish Bone
defb 0,evtMultipleCommands+3					; 3 commands at the same timepoint
defb 	evtSetProgMoveLife,prgFireSlow+11,&23,lifEnemy+10	; Program - Fire Left... Move - wave 10101100 ... Hurt by bullets, hurts player, life 4
defb 	evtSetSprite,TwoFrameSprite+11
defb 	evtSettingsBank_Save,13




; Background Grass
defb 0,evtMultipleCommands +9							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +1	
defb 	evtSingleSprite,24,24+70,16*7+24
defb 	evtSingleSprite,25,24+120,16*7+24
defb 	evtSingleSprite,28,24+160,16*6+24+8
defb 	evtSingleSprite,29,24+20,16*6+24+16
defb 	evtSetProg,0
defb 	evtSingleSprite,TwoFrameSprite+15,24+50,16*9+24+4
defb 	evtSingleSprite,TwoFrameSprite+16,24+100,16*10+24
defb 	evtSingleSprite,TwoFrameSprite+17,24+150,16*10+24+8

;Palette Change
defb 1,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			











; Load Palette

	defb 2,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&5D,&4E,&4B		;Black,DkBlue,LtYellow,White

	;defb 0,240,6,6			; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 5
	;defb 1				
	;defb &54,&55,&43,&4B		;Black,DkBlue,LtYellow,White

	defb 240,26*0+6,5*2+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 2	; Switches
	defb 0	;delay			
	defb &54,&5D,&4A,&4B
	defb 32	;delay			
	defb &54,&57,&5A,&4B



	defb 240,26*1+6,1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &44,&57,&5B,&4B		
	
	
	;defb 1				
	;defb &54,&4C,&56,&4B

; start of level

;defb 4, 136				; Jump to a different level point
;defw 	LevelEndAnim				; pointer
;defb 	145



; Bubble
;defb 5,evtMultipleCommands +2							; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +7	
;defb 	evtSingleSprite,TwoFrameSprite+6,24+80,200+24	; Row 16, last Column, Last Sprite


; Bubble Small
;defb 5,evtMultipleCommands +2							; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +8
;defb 	evtSingleSprite,TwoFrameSprite+7,24+90,200+24	; Row 16, last Column, Last Sprite




; Super Fish
;defb 5,evtMultipleCommands +2							; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +9
;defb 	,mveCustom3+2
;defb 	evtSingleSprite,TwoFrameSprite+1,24+100,200+24	; Row 16, last Column, Last Sprite

; Spitfish
;defb 5,evtMultipleCommands +2							; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +6	
;defb 	evtSingleSprite+12				; Row 16, last Column, Last Sprite


; Pairanah
;defb 7,evtMultipleCommands +2	
;defb 	evtSettingsBank_Load +10
;defb 	evtSingleSprite+7

; Miner Fish
;defb 7,evtMultipleCommands +2	
;defb 	evtSettingsBank_Load +11
;defb 	evtSingleSprite+7	

; FishFace
;defb 7,evtMultipleCommands +2	
;defb 	evtSettingsBank_Load +12
;defb 	evtSingleSprite+5	

; FishFace
;defb 7,evtMultipleCommands +3
;defb 	evtSettingsBank_Load +12
;defb	evtSetMove,&26
;defb 	evtSingleSprite,22,24,50+24


; Fish Bone
;defb 7,evtMultipleCommands +6
;defb 	evtSettingsBank_Load +13
;defb 	evtSingleSprite,128+11,24+160,16*1+24
;defb 	evtSingleSprite+5	
;defb 	evtSingleSprite+7	
;defb 	evtSingleSprite+9	
;defb 	evtSingleSprite+11

; Fish Bone
;defb 7,evtMultipleCommands +9
;defb 	evtSettingsBank_Load +11
;defb	evtSetMove,&25
;defb 	evtSetProg,prgFireSlow+12
;defb 	evtSingleSprite,23,24,16*0+24
;defb 	evtSingleSprite,23,24,16*2+24
;defb 	evtSingleSprite,23,24,16*4+24
;defb 	evtSingleSprite,23,24,16*6+24
;defb 	evtSingleSprite,23,24,16*8+24
;defb 	evtSingleSprite,23,24,16*10+24
;defb 	evtSingleSprite,23,24,16*12+24

; Lilifrog
;defb 8,evtMultipleCommands +2							; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +5
;defb 	evtSingleSprite+12				; Row 16, last Column, Last Sprite



; Tentitack
;defb 3,evtMultipleCommands +3							; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +3							; Load Settings from bank 2
;defb 	evtSetMove,mveWave+%00000100
;defb 	evtSingleSprite+7	

; Tentitack
;defb 3,evtMultipleCommands +3							; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +3							; Load Settings from bank 2
;defb 	evtSetMove,mveWave+%00000101
;defb 	evtSingleSprite+7	

; Tentitack
;defb 3,evtMultipleCommands +3							; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +3							; Load Settings from bank 2
;defb 	evtSetMove,mveWave+%00000110
;defb 	evtSingleSprite+7	

; Tentitack
;defb 3,evtMultipleCommands +3							; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +3							; Load Settings from bank 2
;defb 	evtSetMove,mveWave+%00000111
;defb 	evtSingleSprite+7	




; Spitfish
defb 10,evtMultipleCommands +2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +6	
defb 	evtSingleSprite+12				; Row 16, last Column, Last Sprite

;wave
defb 15,evtMultipleCommands +3						; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +1	
defb 	evtSetProg,0
defb 	evtSingleSprite,TwoFrameSprite+15,24+160,16*12+24


; Lilifrog
defb 20,evtMultipleCommands +2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +5
defb 	evtSingleSprite+9				; Row 16, last Column, Last Sprite


; Starfish Bomber
defb 25,evtMultipleCommands+2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +4							; Load Settings from bank 2
defb 	evtSingleSprite+3	

; Lilifrog
defb 30,evtMultipleCommands +2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +5
defb 	evtSingleSprite+9				; Row 16, last Column, Last Sprite

; Starfish Bomber
defb 35,evtMultipleCommands+2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +4							; Load Settings from bank 2
defb 	evtSingleSprite+3	


; Lilifrog
defb 40,evtMultipleCommands +2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +5
defb 	evtSingleSprite+9				; Row 16, last Column, Last Sprite

; Starfish Bomber
defb 45,evtMultipleCommands+2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +4							; Load Settings from bank 2
defb 	evtSingleSprite+3	

; Lilifrog
defb 50,evtMultipleCommands +2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +5
defb 	evtSingleSprite+9				; Row 16, last Column, Last Sprite


; Bubble
defb 50,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+3
defb 	evtSingleSprite,TwoFrameSprite+6,24+40,200+24	; Row 16, last Column, Last Sprite


;; Background Grass
;defb 50,evtMultipleCommands +2						; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +1	
;defb 	evtSingleSprite,25,24+160,16*7+24
;defb 	evtSetProg,0
;defb 	evtSingleSprite,TwoFrameSprite+15,24+160,16*8+24

; Bubble
;defb 55,evtMultipleCommands +3							; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +8	
;defb 	evtSetMove,mveCustom1+8
;defb 	evtSingleSprite,TwoFrameSprite+7,24+100,200+24	; Row 16, last Column, Last Sprite



; Bubble
defb 60,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+9
defb 	evtSingleSprite,TwoFrameSprite+6,24+80,200+24	; Row 16, last Column, Last Sprite



; Bubble
defb 65,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+10
defb 	evtSingleSprite,TwoFrameSprite+7,24+60,200+24	; Row 16, last Column, Last Sprite



; Bubble Small
;defb 5,evtMultipleCommands +2							; 2 commands at the same timepoint
;defb 	evtSettingsBank_Load +8
;defb 	evtSingleSprite,TwoFrameSprite+7,24+90,200+24	; Row 16, last Column, Last Sprite

; Bubble
defb 70,evtMultipleCommands +3
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+1
defb 	evtSingleSprite,TwoFrameSprite+6,24+120,200+24	; Row 16, last Column, Last Sprite



; Powerup Rate
defb 70,evtMultipleCommands+4			; 2 commands at the same timepoint
defb 	evtSetProgMoveLife,3,&22,64+63	; Program - Bitshift Sprite... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	evtSingleSprite,128+ 13,160+24,10+24	; 	; Single Object sprite 11 (animated)
defb 	evtSingleSprite,128+ 13,160+24,90+24	; 	; Single Object sprite 11 (animated)
defb 	evtSingleSprite,128+ 13,160+24,170+24	; 	; Single Object sprite 11 (animated)


; Super Fish
defb 75,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +9
defb 	evtSetMove,mveCustom3+15
defb 	evtSingleSprite,TwoFrameSprite+1,24+80,200+24	; Row 16, last Column, Last Sprite



; Bubble
defb 80,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+2
defb 	evtSingleSprite,TwoFrameSprite+7,24+130,200+24	; Row 16, last Column, Last Sprite

defb 80,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+4
defb 	evtSingleSprite,TwoFrameSprite+6,24+30,200+24	; Row 16, last Column, Last Sprite

; Super Fish
defb 90,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +9
defb 	evtSetMove,mveCustom3+14
defb 	evtSingleSprite,TwoFrameSprite+1,24+60,200+24	; Row 16, last Column, Last Sprite

; Starfish Bomber
defb 95,evtMultipleCommands+2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +4							; Load Settings from bank 2
defb 	evtSingleSprite+3	


; Super Fish
defb 100,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +9
defb 	evtSetMove,mveCustom3+13
defb 	evtSingleSprite,TwoFrameSprite+1,24+120,200+24	; Row 16, last Column, Last Sprite

; Super Fish
defb 110,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +9
defb 	evtSetMove,mveCustom3+12
defb 	evtSingleSprite,TwoFrameSprite+1,24+80,200+24	; Row 16, last Column, Last Sprite

; Lilifrog
defb 115,evtMultipleCommands +2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +5
defb 	evtSingleSprite+9				; Row 16, last Column, Last Sprite

; Powerup Rate
defb 120,evtMultipleCommands+3			; 2 commands at the same timepoint
defb 	evtSetProgMoveLife,3,&26,64+63	; Program - Bitshift Sprite... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	evtSingleSprite,128+ 14,0+24,50+24	; 	; Single Object sprite 11 (animated)
defb 	evtSingleSprite,128+ 14,0+24,150+24	; 	; Single Object sprite 11 (animated)


; Super Fish
defb 120,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +9
defb 	evtSetMove,mveCustom3+11
defb 	evtSingleSprite,TwoFrameSprite+1,24+120,200+24	; Row 16, last Column, Last Sprite

; Starfish Bomber
defb 125,evtMultipleCommands+2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +4							; Load Settings from bank 2
defb 	evtSingleSprite+3	



; Super Fish
defb 130,evtMultipleCommands +3
defb 	evtSettingsBank_Load +9
defb 	evtSetMove,mveCustom3+10
defb 	evtSingleSprite,TwoFrameSprite+1,24+60,200+24	; Row 16, last Column, Last Sprite

; Lilifrog
defb 135,evtMultipleCommands +2							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +5
defb 	evtSingleSprite+9				; Row 16, last Column, Last Sprite





defb 145,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+9
defb 	evtSingleSprite,TwoFrameSprite+7,24+20,200+24	; Row 16, last Column, Last Sprite


defb 150,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+1
defb 	evtSingleSprite,TwoFrameSprite+6,24+150,200+24	; Row 16, last Column, Last Sprite

defb 155,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+6
defb 	evtSingleSprite,TwoFrameSprite+7,24+25,200+24	; Row 16, last Column, Last Sprite


defb 160,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+2
defb 	evtSingleSprite,TwoFrameSprite+6,24+145,200+24	; Row 16, last Column, Last Sprite

defb 165,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+7
defb 	evtSingleSprite,TwoFrameSprite+7,24+30,200+24	; Row 16, last Column, Last Sprite


defb 170,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+3
defb 	evtSingleSprite,TwoFrameSprite+6,24+140,200+24	; Row 16, last Column, Last Sprite

defb 175,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+8
defb 	evtSingleSprite,TwoFrameSprite+7,24+35,200+24	; Row 16, last Column, Last Sprite


defb 180,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+4
defb 	evtSingleSprite,TwoFrameSprite+6,24+135,200+24	; Row 16, last Column, Last Sprite

defb 185,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+9
defb 	evtSingleSprite,TwoFrameSprite+7,24+140,200+24	; Row 16, last Column, Last Sprite


defb 187,evtSetLevelSpeed,%00000010

defb 188,%01110000+2			; 4 Commands

	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 128	;delays			
	defb &44,&57,&5B,&4B		

;background switch
	defb 240+1,0,13

	defb &80,&00	;1; first line
	defb 190,&00	;5
	defb 110,&50	;10
	defb 98,&00	;16
	defb 60,&00	;17
	defb 02,&00	;17
	defb 255



	
defb 189,%01110000+2			; 4 Commands
	defb 240,26*1+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &44,&57,&5B,&4B	


	;background switch
	defb 	240+1,0,11
	defb &00,&00	;1; first line
	defb 130,&50	;10
	defb 120,&00	;16
	defb 80,&00	;17
	defb 02,&00	;17
	defb 255


defb 190,%01110000+3			; 4 Commands
	defb 240,0,5*1+1		
	defb 1 ; no of switches
	defb 0	;delays			
	defb &54,&57,&5B,&4B	

	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 128	;delays			
	defb &44,&57,&5B,&4B		

;background switch
	defb 240+1,0,11

	defb &00,&00	;1; first line
	defb 150,&50	;10
	defb 140,&00	;16
	defb 100,&00	;17
	defb 02,&00	;17
	defb 255

defb 191,%01110000+2			; 4 Commands
	defb 240,26*0+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &44,&57,&5B,&4B		

;background switch
	defb 240+1,0,13

	defb &00,&00	;1; first line
	defb 170,&50	;10
	defb 160,&00	;16
	defb 120,&00	;17
	defb 20,&50	;17
	defb 02,&00	;17
	defb 255




defb 192,%01110000+5			; 4 Commands


defb 	240+1,0,17*2+1				; (Time,Cmd,Off,Bytes) Load 41 bytes into the background - 41 bytes is the limit
defb &F0,&F0	;1; first line
defb 196,&D0	;2; line num, New byte
defb 190,&70	;3
defb 186,&A0	;4
defb 180,&50	;5
defb 176,&80	;6
defb 170,&20	;7
defb 166,&00	;8
defb 160,&00	;9
defb 36,&20	;10
defb 30,&80	;11
defb 26,&50	;12
defb 20,&A0	;13
defb 16,&70	;14
defb 10,&D0	;15
defb 06,&F0	;16
defb 02,&F0	;17
defb 255

; Load Palette

	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 0				
	defb &44,&57,&4E,&4B

	;defb 0,240,6,6			; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 5
	;defb 1				
	;defb &54,&55,&43,&4B		;Black,DkBlue,LtYellow,White

	defb 240,26*0+6,5*2+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 2	; Switches
	defb 0	;delay			
	defb &44,&57,&49,&4B
	defb 32	;delay			
	defb &44,&57,&5B,&4B




	defb 240,26*1+6,1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0

	defb 240,26*2+6,5*1+1		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1 ; no of switches
	defb 0	;delays			
	defb &44,&42,&4D,&4B		
	
defb 193,evtSetLevelSpeed,%00000100
;End palette batch
; 193+

;CoralAndWeeds 18-21
defb 193,evtMultipleCommands +6	
defb 	evtSettingsBank_Load +1	
defb 	evtSetProg,0
defb 	evtSingleSprite,TwoFrameSprite+18,24+40,24+199-24
defb 	evtSingleSprite,TwoFrameSprite+20,24+160,24+190-24
defb 	evtSingleSprite,TwoFrameSprite+19,24+80,24+185-24
defb 	evtSingleSprite,TwoFrameSprite+21,24+120,24+195-24

; Powerup Rate
defb 193,evtMultipleCommands+2			; 2 commands at the same timepoint
defb 	evtSetProgMoveLife,3,&26,64+63	; Program - Bitshift Sprite... Move - dir Left Slow ... Hurt by bullets, hurts player, life 4
defb 	evtSingleSprite,128+ 12,0+24,100+24	; 	; Single Object sprite 11 (animated)

; Miner Fish
defb 195,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +11
defb 	evtSingleSprite,TwoFrameSprite+8,24+160-16,100+24	; Row 16, last Column, Last Sprite




defb 200,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+10
defb 	evtSingleSprite,TwoFrameSprite+6,24+50,200+24	; Row 16, last Column, Last Sprite

defb 200,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+11
defb 	evtSingleSprite,TwoFrameSprite+7,24+120,200+24	; Row 16, last Column, Last Sprite

; Miner Fish
defb 205,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +11
defb 	evtSingleSprite,TwoFrameSprite+8,24+160-16,100+24	; Row 16, last Column, Last Sprite




defb 210,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+12
defb 	evtSingleSprite,TwoFrameSprite+6,24+130,200+24	; Row 16, last Column, Last Sprite

defb 210,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+13
defb 	evtSingleSprite,TwoFrameSprite+7,24+60,200+24	; Row 16, last Column, Last Sprite

defb 215,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+14
defb 	evtSingleSprite,TwoFrameSprite+6,24+70,200+24	; Row 16, last Column, Last Sprite

defb 215,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+15
defb 	evtSingleSprite,TwoFrameSprite+7,24+120,200+24	; Row 16, last Column, Last Sprite

;Coral and weeds
;defb 215,evtMultipleCommands +4
;defb 	evtSettingsBank_Load +1	
;defb 	evtSetProg,0
;defb 	evtSingleSprite,TwoFrameSprite+18,24+160,24+200-24


defb 220,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+1
defb 	evtSingleSprite,TwoFrameSprite+6,24+120,200+24	; Row 16, last Column, Last Sprite

defb 225,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+2
defb 	evtSingleSprite,TwoFrameSprite+7,24+80,200+24	; Row 16, last Column, Last Sprite

; Pairanah
defb 230,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +10
defb 	evtSingleSprite+7


defb 230,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +7	
defb 	evtSetMove,mveCustom2+3
defb 	evtSingleSprite,TwoFrameSprite+6,24+90,200+24	; Row 16, last Column, Last Sprite

defb 235,evtMultipleCommands +3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +8	
defb 	evtSetMove,mveCustom1+4
defb 	evtSingleSprite,TwoFrameSprite+7,24+110,200+24	; Row 16, last Column, Last Sprite


; Miner Fish
defb 250,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +11
defb 	evtSingleSprite,TwoFrameSprite+8,24+160-16,100+24	; Row 16, last Column, Last Sprite

;Coral and weeds
defb 250,evtMultipleCommands +3
defb 	evtSettingsBank_Load +1	
defb 	evtSetProg,0
defb 	evtSingleSprite,TwoFrameSprite+18,24+160,24+190-24


; Starfish Bomber
defb 5,evtMultipleCommands+3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +4							; Load Settings from bank 2
defb	evtSetMove,&25
defb 	evtSingleSprite,128+4,24,8+24


; Pairanah
defb 20,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +10
defb 	evtSingleSprite+7

; FishFace
defb 25,evtMultipleCommands +3
defb 	evtSettingsBank_Load +12
defb	evtSetMove,&26
defb 	evtSingleSprite,128+22,24,80+24



; Miner Fish
defb 30,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +11
defb 	evtSingleSprite,TwoFrameSprite+8,24+160-16,100+24	; Row 16, last Column, Last Sprite


; Pairanah
defb 35,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +10
defb 	evtSingleSprite+6

;Coral and weeds
defb 35,evtMultipleCommands +3
defb 	evtSettingsBank_Load +1	
defb 	evtSetProg,0
defb 	evtSingleSprite,TwoFrameSprite+20,24+160,24+195-24

; Starfish Bomber
defb 35,evtMultipleCommands+3							; 2 commands at the same timepoint
defb 	evtSettingsBank_Load +4							; Load Settings from bank 2
defb	evtSetMove,&25
defb 	evtSingleSprite,128+4,24,8+24

; Pairanah
defb 40,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +10
defb 	evtSingleSprite+9


; Pairanah
defb 45,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +10
defb 	evtSingleSprite+7


; Pairanah
defb 50,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +10
defb 	evtSingleSprite+6


; Pairanah
defb 55,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +10
defb 	evtSingleSprite+9


; Miner Fish
defb 60,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +11
defb 	evtSingleSprite,TwoFrameSprite+8,24+160-16,100+24	; Row 16, last Column, Last Sprite

; Miner Fish
defb 70,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +11
defb 	evtSingleSprite,TwoFrameSprite+8,24+160-16,100+24	; Row 16, last Column, Last Sprite


; FishFace
defb 75,evtMultipleCommands +3
defb 	evtSettingsBank_Load +12
defb	evtSetMove,&26
defb 	evtSingleSprite,128+22,24,80+24


; FishFace
defb 75,evtMultipleCommands +3
defb 	evtSettingsBank_Load +12
defb	evtSetMove,&26
defb 	evtSingleSprite,128+22,24,100+24


;Coral and weeds
defb 75,evtMultipleCommands +3
defb 	evtSettingsBank_Load +1	
defb 	evtSetProg,0
defb 	evtSingleSprite,TwoFrameSprite+19,24+160,24+199-24

; Pairanah
defb 80,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +10
defb 	evtSingleSprite+5

; Pairanah
defb 85,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +10
defb 	evtSingleSprite+7


; Pairanah
defb 90,evtMultipleCommands +2	
defb 	evtSettingsBank_Load +10
defb 	evtSingleSprite+9


; Super Fish
defb 100,evtMultipleCommands +3
defb 	evtSettingsBank_Load +9
defb 	evtSetMove,mveCustom3+10
defb 	evtSingleSprite,TwoFrameSprite+1,24+60,200+24	; Row 16, last Column, Last Sprite


; Super Fish
defb 100,evtMultipleCommands +3
defb 	evtSettingsBank_Load +10
defb 	evtSetMove,mveCustom3+10
defb 	evtSingleSprite,TwoFrameSprite+1,24+60,200+24	; Row 16, last Column, Last Sprite

;Coral and weeds
defb 100,evtMultipleCommands +3
defb 	evtSettingsBank_Load +1	
defb 	evtSetProg,0
defb 	evtSingleSprite,TwoFrameSprite+18,24+160,24+195-24


; Fish Bone
defb 110,evtMultipleCommands +4
defb 	evtSettingsBank_Load +13
defb 	evtSingleSprite,128+11,24+160,16*1+24
defb 	evtSingleSprite+7	
defb 	evtSingleSprite+11

; Fish Bone
defb 110,evtMultipleCommands +5
defb 	evtSettingsBank_Load +11
defb	evtSetMove,&25
defb 	evtSetProg,prgFireSlow+12
defb 	evtSingleSprite,128+23,24,16*0+24
defb 	evtSingleSprite,128+23,24,16*6+24

defb 120,evtMultipleCommands +3
defb 	evtSettingsBank_Load +13
defb 	evtSingleSprite+5
defb 	evtSingleSprite+9

; Fish Bone
defb 120,evtMultipleCommands +5
defb 	evtSettingsBank_Load +11
defb	evtSetMove,&25
defb 	evtSetProg,prgFireSlow+12
defb 	evtSingleSprite,128+23,24,16*4+24
defb 	evtSingleSprite,128+23,24,16*10+24


LevelEndAnim:
defb 150,%01110000+2			; 3 commands at the same timepoint
defb evtSetProgMoveLife,prgMovePlayer,&24,10
defb 	0,128+	24,140+24,100+24	; 	; Single Object sprite 11 (animated)

defb 150,%10001001			;Call a memory location
defw	ClearBadguys
;Palette Change
defb 152,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&44,&40	

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&44,&40		

	defb 240,26*2+6,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&44,&40			





defb 153,%01110000+4			; 4 Commands
	defb 240,0,6				; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54	

	defb 240,26*0+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*1+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 21*2+5
	defb 0
	defb 1				
	defb &54,&54,&54,&54		

	defb 240,26*2+6,6		; (Time,Cmd,Off,Bytes) load 5 bytes into the palette Offset 0
	defb 1
	defb 1				
	defb &54,&54,&54,&54		

defb 153,evtCallAddress			;Call a memory location
defw	EndLevel


EndLevel:
	pop hl	;
	ld hl,	&0106 				;load level 2
	jp	Akuyou_ExecuteBootStrap	; Start the game, no return








limit &4000


LevelInit:

	ld a, StarArraySize
	ld hl,StarArrayPointer
	call AkuYou_StarArrayInit_Enemy 

	ld a, PlayerStarArraySize
	ld hl,PlayerStarArrayPointer
	call AkuYou_StarArrayInit_Player 

	ld a,ObjectArraySize
	ld hl,ObjectArrayPointer
	call AkuYou_ObjectArray_Init


	call Akuyou_Music_Restart

	ld hl,LevelSprites		
	ld de,&1000
	call AkuYou_SpritePointerInit


	ld a,1
	ld bc,RasterColors_ColorArray1
	ld de,RasterColors_ColorArray2
	ld hl,RasterColors_ColorArray3
	ld ix,RasterColors_ColorArray4
	ld iy,null
	call Akuyou_RasterColors_SetPointers


	ld hl,EventStreamArray		;Event Stream
	ld de,Event_SavedSettings	;Saved Settings
	call AkuYou_Event_StreamInit


	;Make sure you Init the event stream first, else the rastercolor data will be zero! 
	call Akuyou_ScreenBuffer_Init
	call Akuyou_RasterColors_Init

	;call RasterColors_Reset
LevelLoop:
	ifdef debug
	call Timer_Start
	endif
	;halt
	call Akuyou_Background_Clear
	;ld l,&08
	;call Timer_Stop
	;ld l,&09
	;call Timer_Stop
	;ld a,"B"
	;call &bb5a 

	;halt
	call Akuyou_EventStream_Process
	;ld l,&0a
	;call Timer_Stop
	;ld a,"S"
	;call &bb5a 

	;halt
	call Akuyou_ObjectArray_Redraw
	;ld l,&0b
	;call Timer_Stop
	;ld a,"O"
	;call &bb5a 


	;halt
	call Akuyou_Player_Handler
	;ld l,&0c
	;call Timer_Stop
	;ld a,"P"
	;call &bb5a 



	call Akuyou_StarArray_Redraw
	;ld l,&0d
	;call Timer_Stop
	;ld a,"S"
	;call &bb5a 


	call AkuYou_Player_StarArray_Redraw
	;ld l,&0e
	;call Timer_Stop
	;ld a,"F"
	;call &bb5a 

	;halt
	call AkuYou_Player_DrawUI

	call Akuyou_PlaySfx

	ifdef debug
		ld l,&0f
		call Timer_Stop
		call ShowLevelTime
	endif

	call Akuyou_ScreenBuffer_Flip
	jp LevelLoop

LevelShutdown:

ret
Timer_Start:
ld      hl,(&b8b4) ;this is the memloc KL_Time_Please actually uses!
;call &BD0D ;KL_TIME_PLEASE
ld a,l
ld (Timer_LastTime_Plus2-2),a
ld a,h
ld (Timer_LastTime_Plus2-1),a
ret

ShowLevelTime:
	;ld hl,&C000
	;call Akuyou_ShowSprite_SetBankAddr
	call Akuyou_SpriteBank_Font

	ld hl,&1001
	call Akuyou_DrawText_LocateSprite

	call Akuyou_GetLevelTime
	push bc	
	call ShowHex
	pop bc
	ld a,b
	call ShowHex
ret

Timer_Stop:
	;ld hl,&C000
	;call Akuyou_ShowSprite_SetBankAddr
	call Akuyou_SpriteBank_Font
;	ret
	ld h,&03
	ld l,&10
	call Akuyou_DrawText_LocateSprite ; set location
	;call &BD0D ;KL_TIME_PLEASE
	ld      hl,(&b8b4) ;this is the memloc KL_Time_Please actually uses!
	ld bc,&0000 :Timer_LastTime_Plus2
	;turn BC negative
	ld a,b
	cpl
	ld b,a
	ld a,c
	cpl
	ld c,a
	inc bc

	add hl,bc

	ld a,l
	call ShowHex
	ret

ShowHex:

	push af         ;store original byte value
	rrca            
	rrca
	rrca
	rrca
	call ShowHexDigit
	pop af          ;retrieve original byte value

ShowHexDigit:
;	and %00001111   ;isolate lower nibble. (This contains the digit value 0...15)
;	add a,"0"       ;add ASCII for 0. Digits 0...9 become "0"..."9", digits 10..15
;	cp "9"+1        
;	jr c,ShowHexDigitNum     ;if number is in digit range 0...9, display digit
;	add a,"A"-"9"-1 ;modify ASCII value so that digits in the range 10...15
and %00001111   ;isolate lower nibble. (This contains the digit value 0...15)
cp &a           ;Less than 10?  Set carry if so
sbc a,&69
daa             ;Because previous instruction was a subtract operation this
                ;is known as 'das' in x86
ShowHexDigitNum:
	jp Akuyou_DrawText_CharSprite   ;display digit


ClearBadguys:
	ld a,1
	ld i,a
	push hl
	call Akuyou_DoSmartBombCall
	pop hl
null:ret




CustomMove1:
	di
	exx
	ld hl,CustomMovePattern1
	ld (CustomPatternJump_Plus2-2),hl
	exx
jr CustomMovePattern

CustomMove2:
	di
	exx
	ld hl,CustomMovePattern2
	ld (CustomPatternJump_Plus2-2),hl
	exx
jr CustomMovePattern
CustomMove3:
	di
	exx
	ld hl,CustomMovePattern3
	ld (CustomPatternJump_Plus2-2),hl
	exx
jr CustomMovePattern



CustomMovePattern:		; B=X C=Y D=Move
di



;		ld a,iyl ; Program Code
;		ld a,ixl ;Life  - MOVED INTO af'
;		ld a,iyh ;spr
;		ld (hl),ixh ;Move
;		ld (hl),b ;X
;		ld (hl),c ;Y

		

	ld a,ixl	;lifCustom 
	ex af,af'

	ld a,d
	exx
	push ix


		and %00001111
		ld hl,CustomRam
			
			ld d,0
			ld e,a
			add hl,de
			add hl,de
		push hl
		pop ix

		call Akuyou_Timer_GetTimer
		ld d,a
		ld a,i	; Level time
		ld e,a


		;dont update more than once per tick! 
		ld a,(ix+1)
		cp e
		jr z,CustomMovePattern_NoTick	
		ld a,e
		ld (ix+1),e

		;see if this is our first run
		ex af,af'
			cp 250
			call nc,CustomMovePattern_Init
		ex af,af'


		; here is where we make some moves!
		exx
		call CustomMovePattern1 :CustomPatternJump_Plus2
		exx
		;increment the pos
	

CustomMovePattern_NoTick:
		
		jp CustomMovePattern_Done

CustomMovePattern_Done:
	pop ix
	exx

	ex af,af'

	ld ixl,a	;lifCustom 


ei
ret
CustomMovePattern_Init:

	xor a
	ld (ix+0),a
	ld (ix+1),a
	ld a,lifEnemy+6			;New Life

ret


CustomMovePattern1:
	ld a,(ix+0)
	and %00111111
CustomMovePattern1Continue
		
	cp 32
	jr C,CustomMovePattern1Left

	inc b
	jr CustomMovePattern1Done

CustomMovePattern1Left:
	dec b
	jr CustomMovePattern1Done

CustomMovePattern1Done:	
	dec c	;m
	dec c	;m

	ld a,(ix+0)
	inc a
	ld (ix+0),a	



	cp 64
	jp NC,CustomMovePattern1Explode
ret
CustomMovePattern1Explode:
	ld iyl,prgFireFast+14		; Program Fire


	cp 66
	jp NC,CustomMovePatternKill
	;ex af,af'
	;dec a		;reduce our life
	;dec a		;reduce our life
	;push af
	;and %00111111
	;jp z,CustomMovePattern1Kill
	;pop af
	

	;ex af,af'
	



ret
CustomMovePatternKill:
	;ex af,af'
	;xor a
	
	ld b,0
	ld c,b
	ld D,b
	;ex af,af'
ret


CustomMovePattern2:
	ld a,(ix+0)
	and %00111111
CustomMovePattern2Continue
		
	cp 32
	jr C,CustomMovePattern2Left

	inc b
	jr CustomMovePattern2Done

CustomMovePattern2Left:
	dec b
	jr CustomMovePattern2Done


CustomMovePattern2Done:	

	dec c	;m


	ld a,(ix+0)
	inc a
	ld (ix+0),a	

	cp 168
	jp NC,CustomMovePattern2Explode

ret
CustomMovePattern2Explode:
	ld iyl,prgFireFast+13		; Program Fire


	cp 170
	jp NC,CustomMovePatternKill
	


ret

CustomMovePattern3:
	ld a,(ix+0)
	;and %00111111
CustomMovePattern3Continue
		
	cp 64
	jr C,CustomMovePattern3up
	inc c
	inc c
	inc c
	jr CustomMovePattern3Done

CustomMovePattern3up:

	dec c
	dec c
	dec c
	jr CustomMovePattern3Done


CustomMovePattern3Done:	
	ld a,(ix+0)
	inc a
	ld (ix+0),a	

	jr CustomMovePattern3Explode

ret
CustomMovePattern3Explode:
	;and %00011110
	;rrca
	;add prgFireFast+16
	

;	ld iyl,a		; Program Fire


	cp 128
	jr z,CustomMovePatternKill
	


ret
CustomProgram1:
	call Akuyou_Timer_GetTimer
	ld a,i	; Level time
	and %00000011
	;rrca
	add 16
	ld iyl,a		; Program Fire
	push bc
	push de
	push iy
	call Akuyou_FireStar
	pop iy
	pop de
	pop bc


	ld a,iyl
	add 4
	ld iyl,a
	jp Akuyou_FireStar


CustomProgram2:
	call Akuyou_Timer_GetTimer
	ld a,i	; Level time
	bit 0,a
	jr z,CustomProgram2_Fire2

	ld a,17
	ld iyl,a
	jp Akuyou_FireStar

CustomProgram2_Fire2:
	ld a,23
	ld iyl,a
	jp Akuyou_FireStar

limit &FFFF
org &3ff0
jp LevelInit; - Level Start &3ff0
jp LevelLoop; - Level loop &3ff3
jp null     ; - Level resume &3ff6
jp null     ; - Level Shutdown &3ff9



save direct "T10-SC1.D02",&2A00,&1600	;address,size...}[,exec_address]



;Time,type,Sprite,XY (16 px precision)

; Types:
;type XXXX----
;     00000000 A X Y = (0)  add one object A=sprnum, X , Y
;     00000001 Y    	Add one sprite to pos Y Far right (Same sprite as last time
;     0000yyyy A	2-13 add one 24 pixel object far right X=160+24 Y*16 -8 (Same sprite as last time
;     0001xxxx A B = (16) add  xxxx objects
;     0010xxxx X B = (32) add  xxxx objects all on column X
;     0011xxxx X Y S = (48) add  xxxx objects all on column X, Ypos Spaced S apart vertically
;     0100xxxx X Y   = (64) add stars to X,Y (pattern xxxx)
;     0101       Unused
;     0110       Unused
;     0111xxxx  = (112) Read Multiple events at the same time point

;     10000000 M L = (128) Change object movement to M, Life to L
;     10000001 P = (129) Change object Program
;     10000010 L = (130) Change object Life
;     10000011 M = (131) Change object Move
;     10000100 P M L = (132) Change object Program Move and Life
;     10000101 S = (133) Change object Sprite (only works with 0000XXXX )
;     10000110 (134) Add Objects to Front of list first (Background)
;     10000111 (135) Add Objects to Back of list first (Foreground)
;     10001000 L H T (136) = Load HL as next event pointer, change time to T
;     10001001 L H   (137) = Call HL - (untested)
;     10001010 L H   (138) = Load last added object address to address HL
;     10011111 B = Save to bank B
;     1001XXXX 	Load object settings (Prog, Move,Life) from XXXX bank (0-14 - see above 15 is save command)
;		Use this function to create template enemy moves and background object types
;     1010       Unused
;     1011       Unused	
;     1100XXXX   Unused
;     1101XXXX   Unused
;     1110XXXX   Unused
;     1111XXXX   Reprogram memory chunk

;     1111XXXX   Reprogram memory chunk
;     11110000 O B	X X X  = (240) Reprogram palette (B no of Bytes, O = offset; X X X byte data)
;     11110001 O B	X X X  = (240) Reprogram Background (B no of Bytes (up to 41), O = offset; X X X byte data)
;     11110010 LH 	= when an object is shot jump to HL (Akuyou_Object_DecreaseLifeShot is true hitcounter)
;     11110011 1P2	= Scroll rate 1 before P then 2 (1 must be faster than 2)
;     11110100 LH	= Reprogram Custom Move1
;     11110101 LH	= Reprogram Custom Move2

; Life BPxxxxx 		B=hurt by bullets , P hurts player, xxxxxx = Life ... Life decreases either over time or due to hits %00000000 means an immortal object which will only dissapear if it goes ofscreen

;Domoves
;0MYYYXXX	; Linear move
;11ddXXXX	; Background (Slow) move
;100001XX	; Seek player 1 speed -----XX1
;1010DSPP	D = Depth bit, S= Speed, PP Position
